private import registry2;
private import std.stdio : writefln;
private import std.utf; /* for toUTF8, validate */
private import std.stream; /* for File */

pragma(lib, "advapi32.lib");

void main()
{
    Key HKCR = Registry.localMachine;
    Key UNINST = HKCR.getKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall");

    File outFile = new File(r"Installed3.txt", FileMode.OutNew);
    outFile.close();
    outFile = new File(r"Installed2.txt", FileMode.OutNew);
    outFile.close();
    outFile = new File(r"Installed.txt", FileMode.OutNew);

    foreach(Key key; UNINST.keys)
    {
        outFile.writeString(key.name() ~ "\r\n");

        foreach(Value val; key.values)
        {
            try
            {
                switch (val.type){
                case REG_VALUE_TYPE.REG_SZ:
                case REG_VALUE_TYPE.REG_EXPAND_SZ:
                case REG_VALUE_TYPE.REG_DWORD:
                case REG_VALUE_TYPE.REG_QWORD:
                    char[] name = val.name;
                    if (name.length == 0){
                        name = "Default";
                    }
                    outFile.writeString("  " ~ name ~ "  " ~ val.value_SZ() ~ "\r\n");
                    break;
                default:
                    // noop
                }
            }
            catch(UtfException)
                outFile.writeString("  # UTF Problem #" ~ "\r\n");
            catch(Exception)
                outFile.writeString("  # Error #" ~ "\r\n");

        }
    }
    outFile.close();
}